#<profile4xi profile = "02" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "processlocalset4xi.py">
#<abstract4xi abstract = "provides ProcessLocalSet4Xi class"/>
#<refer4xi reference = "managers.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'ProcessLocalSet4Xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import weakref
    import threading
    from traceback import format_exc
    import copyreg         
except:
    pass
try:                 # rare ones
    import array
    import queue            
except:
    pass 
try:                 # imported-as ones 
    pass        
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import ProcessLocalSet
except:
    print("processlocalset4xi.py *** failed in from multiprocessing.managers import ProcessLocalSet ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from reason_object4xi import reason_object4xi
from register_after_fork4xi import register_after_fork4xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi
 
#"
#/>


#
# =================================================================================================
#<class4xi class = "ProcessLocalSet4Xi" base = "set" child = "None"
#   synopsis = "Subclass of set which get cleared after a fork"
#   usage = "
#    baseproxy4xi.py
#        BaseProxy4Xi:
#            __init__:
#               if tls_idset is None:
#                   tls_idset = ForkAwareLocal4Xi(), ProcessLocalSet4Xi()              
#
#"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
#
class ProcessLocalSet4Xi(set):
    '''
    Subclass of set which get cleared after a fork
    '''
    
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('sense', 'reason', 'ace')          
    #"
    #/>    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-ProcessLocalSet4Xi" usage = "initializes ProcessLocalSet4Xi">                             
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __init__(self):
        '''
        initializes ProcessLocalSet4Xi 
        '''
                                        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
             
        class2print = "ProcessLocalSet4Xi"
        method2print = "__init__"
         
        message2print = "{started" + "; init-of-ProcessLocalSet4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 03:25:57 01/15/13 Pacific Standard Time
         
        message2print = "{borning" + "; processlocalset2xi-of-ProcessLocalSet4Xi-borning: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 03:25:57 01/15/13 Pacific Standard Time
                     
        message2print = "{inheriting" + "; set-inheriting-by-processlocalset2xi-of-ProcessLocalSet4Xi: " + str(set)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'set'>
                                                        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
        try:          
            register_after_fork4xi(self, lambda obj: obj.clear())
            
            message2print = "{performed" + "; register-after-fork4xi-performed-by-init-of-ProcessLocalSet4Xi: " + str(register_after_fork4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <function register_after_fork4xi at 0x0000000002DFB158>
           
                         
        except:
            message2print = "{hit" + "; register-after-fork4xi-hit-by-init-of-ProcessLocalSet4Xi: " + " *** " + str(register_after_fork4xi)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                    
                                
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
                     
        message2print = "{inherited" + "; set-inherited-by-processlocalset2xi-of-ProcessLocalSet4Xi: " + str(set)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'set'>
            
        message2print = "{activated" + "; processlocalset2xi-of-ProcessLocalSet4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # time: 03:25:57 01/15/13 Pacific Standard Time         
                        
        message2print = "{returning" + "; init-of-ProcessLocalSet4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # time: 03:25:57 01/15/13 Pacific Standard Time
                        
    #</methodize4xi>                
                        
                
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reduce-of-ProcessLocalSet4Xi" usage = "returns type">                          
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------        
    def __reduce__(self):
        '''
        ProcessLocalSet4Xi method __reduce__: returns type
        '''
                                        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
             
        class2print = "ProcessLocalSet4Xi"
        method2print = "__reduce__"

        message2print = "{started" + "; reduce-of-ProcessLocalSet4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 03:25:57 01/15/13 Pacific Standard Time
                                      
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
        
        message2print = "{returning" + "; type-returning-by-reduce-of-ProcessLocalSet4Xi: " + str(type(self)) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        # <class 'processlocalset4xi.ProcessLocalSet4Xi'>                
      
        return type(self), ()
    #</methodize4xi>
            
                                      
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-ProcessLocalSet4Xi" usage = "senses ProcessLocalSet4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses ProcessLocalSet4Xi class objects
        '''
                                        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
                
        
        class2print = 'ProcessLocalSet4Xi'
        method2print = 'sense'
        

        message2print = "{started" + "; sense-of-ProcessLocalSet4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; ProcessLocalSet4Xi-sensing-by-sense-of-ProcessLocalSet4Xi: " + str(ProcessLocalSet4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                       
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-ProcessLocalSet4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
    
        
        
      
        message2print = "{sensed" + "; ProcessLocalSet4Xi-sensed-by-sense-of-ProcessLocalSet4Xi: " + str(ProcessLocalSet4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-ProcessLocalSet4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                  
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-ProcessLocalSet4Xi" usage = "reasons ProcessLocalSet4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons ProcessLocalSet4Xi class objects
        '''
                                        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
               
        
        class2print = 'ProcessLocalSet4Xi'
        method2print = 'reason'


        message2print = "{started" + "; reason-of-ProcessLocalSet4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; ProcessLocalSet4Xi-reasoning-by-reason-of-ProcessLocalSet4Xi: " + str(ProcessLocalSet4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-ProcessLocalSet4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; ProcessLocalSet4Xi-reasoned-by-reason-of-ProcessLocalSet4Xi: " + str(ProcessLocalSet4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-function-returning-by-reason-of-ProcessLocalSet4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                          
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-ProcessLocalSet4Xi" usage = "aces ProcessLocalSet4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/> 
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces ProcessLocalSet4Xi class objects 
        '''
                                        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
                   
        
        
        class2print = 'ProcessLocalSet4Xi'
        method2print = 'ace'
        

        message2print = "{started" + "; ace-of-ProcessLocalSet4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
              
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; ProcessLocalSet4Xi-acing-by-ace-of-ProcessLocalSet4Xi: " + str(ProcessLocalSet4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                     
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-ProcessLocalSet4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; ProcessLocalSet4Xi-aced-by-ace-of-ProcessLocalSet4Xi: " + str(ProcessLocalSet4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-ProcessLocalSet4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of processlocalset4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>



